Bug 1412798 - Review Request: python-fmn-sse - A server-sent events server that integrates with FMN
Summary: Review Request: python-fmn-sse - A server-sent events server that integrates...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Ben Rosser
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-12 20:01 UTC by Jeremy Cline
Modified: 2017-02-15 20:53 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-02-15 20:51:08 UTC
rosser.bjr: fedora-review+


Attachments (Terms of Use)

Description Jeremy Cline 2017-01-12 20:01:12 UTC
Spec URL: https://jcline.fedorapeople.org/python-fmn-sse.spec
SRPM URL: https://jcline.fedorapeople.org/python-fmn-sse-0.2.1-1.fc25.src.rpm
Description:
fmn is a family of systems to manage end-user notifications triggered by
fedmsg, the FEDerated MESsage bus. The FMN Server-Sent Events server allows
users to view their fedmsg feed in real-time using server-sent events. It relies
on a service to populate the RabbitMQ message queues for it. Typically, this is
done with the FMN core services.

Fedora Account System Username: jcline

Scratch build: koji.fedoraproject.org/koji/taskinfo?taskID=17261585

Comment 1 Ben Rosser 2017-01-18 19:31:15 UTC
Taken, any chance you could look at https://bugzilla.redhat.com/show_bug.cgi?id=1410651?

Comment 2 Ben Rosser 2017-01-20 05:06:55 UTC
Package Review
==============

Issues
======

Things mostly look okay, just a couple minor comments:

* For python-devel and python-flake8, you should instead BuildRequires
  the python2 versions of these packages, especially python-devel.

* In your %check section, you invoke python and python3 directly;
  as per the guidelines you should use %{__python2} and %{__python3}
  macros. (e.g. https://fedoraproject.org/wiki/Packaging:Python).

* fedora-review picked up that the SRPM spec file differs from the
  uploaded one (see below for the diff). In particular in the SRPM
  it seems that you tried to define the subpackage %descriptions using
  the main package description, which rpmlint does not like:

python2-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}
python3-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}

  On the version of the spec attached to the bug this isn't a problem; please
  make sure you import the right version of the spec when it comes time to import
  the package.

* While all unit tests pass, messages like the following seem to get
  output in the log. I'm assuming this is fine, because (as I said) the
  tests do pass, but I figured it was worth mentioning. (This isn't a
  review blocker, just a comment):

.Unhandled error: [Failure instance: Traceback: <class 'TypeError'>: 'Mock' object is not iterable
/builddir/build/BUILD/fmn.sse-0.2.1/tests/test_server.py:68:test_render_GET_whitelist
/builddir/build/BUILD/fmn.sse-0.2.1/fmn_sse/server.py:180:render_GET
/builddir/build/BUILD/fmn.sse-0.2.1/fmn_sse/server.py:222:new_subscription
/usr/lib64/python3.6/site-packages/twisted/internet/defer.py:1331:unwindGenerator
--- <exception caught here> ---
/usr/lib64/python3.6/site-packages/twisted/internet/defer.py:1185:_inlineCallbacks
/builddir/build/BUILD/fmn.sse-0.2.1/fmn_sse/server.py:135:queue



Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* GPL (v2 or later)", "GPL (v2 or later)",
     "Unknown or generated". 16 files have unknown license. Detailed output
     of licensecheck in /home/bjr/Programming/fedora/reviews/1412798
     -python-fmn-sse/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package requires other packages for directories it uses.
     Note: No known owner of /usr/lib/python3.6, /usr/lib/python3.6/site-
     packages
[x]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib/python3.6/site-
     packages, /usr/lib/python3.6
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 6 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
     fmn-sse-common , python2-fmn-sse , python3-fmn-sse
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: python-fmn-sse-common-0.2.1-1.fc26.noarch.rpm
          python2-fmn-sse-0.2.1-1.fc26.noarch.rpm
          python3-fmn-sse-0.2.1-1.fc26.noarch.rpm
          python-fmn-sse-0.2.1-1.fc26.src.rpm
python2-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}
python3-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}
python-fmn-sse.src: W: spelling-error %description -l en_US fedmsg -> Feds
python-fmn-sse.src: W: spelling-error %description -l en_US realtime -> mealtime, real time, real-time
4 packages and 0 specfiles checked; 4 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
python2-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}
python3-fmn-sse.noarch: W: unexpanded-macro %description -l C %{description}
3 packages and 0 specfiles checked; 0 errors, 2 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/bjr/Programming/fedora/reviews/1412798-python-fmn-sse/srpm/python-fmn-sse.spec	2017-01-19 23:27:53.519622570 -0500
+++ /home/bjr/Programming/fedora/reviews/1412798-python-fmn-sse/srpm-unpacked/python-fmn-sse.spec	2017-01-12 14:39:11.000000000 -0500
@@ -15,5 +15,5 @@
 fmn is a family of systems to manage end-user notifications triggered by
 fedmsg, the FEDerated MESsage bus. The FMN Server-Sent Events server allows
-users to view their fedmsg feed in real-time using server-sent events. It relies
+users to view their fedmsg feed in realtime using server-sent events. It relies
 on a service to populate the RabbitMQ message queues for it. Typically, this is
 done with the FMN core services.
@@ -50,9 +50,5 @@
 
 %description -n python2-%{pkgname}
-fmn is a family of systems to manage end-user notifications triggered by
-fedmsg, the FEDerated MESsage bus. The FMN Server-Sent Events server allows
-users to view their fedmsg feed in real-time using server-sent events. It relies
-on a service to populate the RabbitMQ message queues for it. Typically, this is
-done with the FMN core services.
+%{description}
 
 
@@ -79,9 +75,5 @@
 
 %description -n python3-%{pkgname}
-fmn is a family of systems to manage end-user notifications triggered by
-fedmsg, the FEDerated MESsage bus. The FMN Server-Sent Events server allows
-users to view their fedmsg feed in real-time using server-sent events. It relies
-on a service to populate the RabbitMQ message queues for it. Typically, this is
-done with the FMN core services.
+%{description}
 
 


Requires
--------
python2-fmn-sse (rpmlib, GLIBC filtered):
    python(abi)
    python-fmn-sse-common
    python2-fedmsg-core
    python2-pika
    python2-six
    python2-twisted
    systemd

python-fmn-sse-common (rpmlib, GLIBC filtered):

python3-fmn-sse (rpmlib, GLIBC filtered):
    python(abi)
    python-fmn-sse-common
    python3-fedmsg-core
    python3-pika
    python3-six
    python3-twisted
    systemd



Provides
--------
python2-fmn-sse:
    python-fmn-sse
    python2-fmn-sse
    python2.7dist(fmn-sse)
    python2dist(fmn-sse)

python-fmn-sse-common:
    python-fmn-sse-common

python3-fmn-sse:
    python3-fmn-sse
    python3.6dist(fmn-sse)
    python3dist(fmn-sse)



Source checksums
----------------
https://github.com/fedora-infra/fmn.sse/archive/v0.2.1/fmn.sse-0.2.1.tar.gz :
  CHECKSUM(SHA256) this package     : 15a3ad9ed022a0937d9862c3a093f3060c6a1a127ec13395d6b2a06a0ce288c3
  CHECKSUM(SHA256) upstream package : 15a3ad9ed022a0937d9862c3a093f3060c6a1a127ec13395d6b2a06a0ce288c3


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -b 1412798
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 3 Jeremy Cline 2017-01-20 19:57:37 UTC
Thanks for the review!

I remember trying to macro the description and failing, I guess I forgot to rebuild the srpm. I've changed the buildrequires to be explicit about python2, used the macros in the tests, and made sure I didn't tweak the spec file again without rebuilding the SRPM :).

As for the test output, it was on my mental list of things to investigate, but I clearly forgot so I filed a bug about it: https://github.com/fedora-infra/fmn.sse/issues/75 - thanks for reminding me!

SRPM URL: https://jcline.fedorapeople.org/python-fmn-sse-0.2.1-2.fc25.src.rpm
Spec URL: https://jcline.fedorapeople.org/python-fmn-sse.spec

Comment 4 Ben Rosser 2017-01-20 21:03:51 UTC
Great, package approved. :)

Comment 5 Jeremy Cline 2017-01-20 22:15:04 UTC
Cheers!

Comment 6 Gwyn Ciesla 2017-01-23 13:52:48 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-fmn-sse

Comment 7 Fedora Update System 2017-02-02 19:12:29 UTC
python-fmn-sse-0.2.1-2.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-9499297a7f

Comment 8 Fedora Update System 2017-02-02 19:19:02 UTC
python-fmn-sse-0.2.1-2.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-4967928b60

Comment 9 Fedora Update System 2017-02-02 20:07:55 UTC
python-fmn-sse-0.2.1-2.el7 has been submitted as an update to Fedora EPEL 7. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-75d2cd125d

Comment 10 Fedora Update System 2017-02-03 22:54:51 UTC
python-fmn-sse-0.2.1-2.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-4967928b60

Comment 11 Fedora Update System 2017-02-03 23:50:00 UTC
python-fmn-sse-0.2.1-2.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-9499297a7f

Comment 12 Fedora Update System 2017-02-04 01:20:18 UTC
python-fmn-sse-0.2.1-2.el7 has been pushed to the Fedora EPEL 7 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2017-75d2cd125d

Comment 13 Fedora Update System 2017-02-15 20:51:08 UTC
python-fmn-sse-0.2.1-2.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 14 Fedora Update System 2017-02-15 20:53:20 UTC
python-fmn-sse-0.2.1-2.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.